//-----------------------------------------------------------
//AugMod v1.0b
//-----------------------------------------------------------

class AugMod extends Mutator;

var bool bInit;
// --------------------------------------------------------------------------------------
// ScoreKill()
// --------------------------------------------------------------------------------------

function ScoreKill(pawn Killer, pawn Other) 
{
local int KillerStreak, KilledStreak;

if ((Killer == none) || (Other==none)||(TeamDMGame(level.game).ArePlayersAllied(DeusExPlayer(Other),DeusExPlayer(Killer))))
	return;

KillerStreak = ((Killer.PlayerReplicationInfo.Streak) - 1);  
KilledStreak = Other.PlayerReplicationInfo.Streak;

 removeaugs(2, Killer);

 super.ScoreKill(Killer, Other);
}

// --------------------------------------------------------------------------------------
// PreBeginPlay () 
// --------------------------------------------------------------------------------------

function PreBeginPlay()
{
  local DeusExMPGame AugGame;

  if (bInit) 
	return;

  AugGame = DeusExMPGame(level.game);

  if (AugGame  == none)
	return;

   AugGame.SkillsTotal = 0;
   AugGame.SkillsAvail = 2000;
   AugGame.SkillsPerKill = 2000;
   AugGame.InitialAugs = 9;
   AugGame.AugsPerKill = 0;
   AugGame.MPSkillStartLevel = 1;

   bInit=true;
}

// --------------------------------------------------------------------------------------
// RemoveAugs()
// --------------------------------------------------------------------------------------

function RemoveAugs(int NumAugs,Pawn Killer0)
{
   local Augmentation CurrentAug;
   local int PriorityIndex;
   local int AugsLeft;
   local DeusExPlayer player0;
	
   if (Role < ROLE_Authority)
      return;   

   player0 = DeusExPlayer(Killer0);
   AugsLeft = NumAugs;

   for (PriorityIndex = ((ArrayCount(player0.AugPrefs))-1); PriorityIndex >= 2; PriorityIndex--)
   {
      if (AugsLeft <= 0)
		return;
      if (player0.AugPrefs[PriorityIndex] != '2')
      {  			

      for (CurrentAug = player0.AugmentationSystem.FirstAug; CurrentAug != None; CurrentAug = CurrentAug.next)
      {
         if ((CurrentAug.Class.Name == player0.AugPrefs[PriorityIndex]) && (CurrentAug.bHasIt == True))
         
	 {
		 log("Removing "$CurrentAug.Class.Name);
		 if (CurrentAug.bIsActive)
			CurrentAug.Deactivate();
		 CurrentAug.bHasIt = false;
		 player0.AugmentationSystem.RefreshAugDisplay();
		 AugsLeft = AugsLeft - 2;		
         } 
      }    	
   }               
   }       
   if (AugsLeft <= 0)
		return;	

}


// ----------------------------------------------------------------------
// NumOfAugs()
// ----------------------------------------------------------------------
function int NumOfAugs(DeusExPlayer player)
{
	local Augmentation Aug0;
	local int count;

	if (player == None)
		return 0;

	count = 0;
	Aug0 = player.AugmentationSystem.FirstAug;
	while(Aug0 != None)
	{
		if (Aug0.bHasIt)
			count++;
		Aug0 = Aug0.next;
	}

	return count;
}